import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { connect } from 'dva';
import {
  ButtonArea,
  CellHeader,
  Button,
  CellBody,
  CellFooter,
  Form,
  FormCell,
  Input,
  Label,
  Toptips,
  Page,
  Footer,
  FooterText,
  Icon
} from 'react-weui';
//import styles
import 'weui';
import 'react-weui/build/packages/react-weui.css';
import styles from './IndexPage.css';


class IndexPage extends React.Component{
  constructor(props) {
    super(props);
    this.ti = this.ti.bind(this);
  }
  //手机号判断
  telCheck=(event)=>{
    const tel=event.target.value;
    let reg=/^1[34578]\d{9}$/;
    if(reg.test(tel)===false){
      this.props.dispatch({ type: 'login/setShowToptips', payload: { ShowToptips:true,errormsg:"请输入正确的手机号" } });
      window.setTimeout(e=> this.props.dispatch({ type: 'login/setShowToptips', payload: { ShowToptips:false } }), 2000)
    }else{
      this.props.dispatch({ type: 'login/setTelnum', payload: { telNum:tel } });
    }
  };
  //验证码判断
  telYanZhengMa=(event)=>{
    const tel=event.target.value;
    let reg=/\d{4}$/;
    if(reg.test(tel)===false){
      this.props.dispatch({ type: 'login/setShowToptips', payload: { ShowToptips:true,errormsg:"请输入正确的验证码" } });
      window.setTimeout(e=> this.props.dispatch({ type: 'login/setShowToptips', payload: { ShowToptips:false } }), 2000)
    }else{
      this.props.dispatch({ type: 'login/setYanZhengMa', payload: { YanZhengMa:tel } });
    }
  };

  //一秒减一
  ti = function(number){
    let t = setInterval(function () {
      number--;
      if(number<1){
        clearInterval(t);
      }
      this.props.dispatch({type:'login/setTime',payload:{MyTimes:number}});
    }.bind(this),1000);
  }
  //发送验证码
  sendCheckNum = () => {
    this.ti(60);
    // 1.检验改手机号是否存在系统中，如果不存在，无法注册
    this.props.dispatch({type:'login/checkNumber',payload:{}})
  };
  // 注册
  registerClick=()=>{
    this.props.dispatch({ type: 'login/checkYanZhengMa', payload: {} });
  };
  render(){
    let time = this.props.login.MyTimes;
    let button = (<CellFooter>
                  <Button type="vcode" onClick={this.sendCheckNum} style={{height:"25px",lineHeight:"25px"}}>发送</Button>
                </CellFooter>);
    if(time>0 && time<60){
      button = (<CellFooter>
        <Button type="vcode" style={{height:"25px",lineHeight:"25px"}}>{time}</Button>
      </CellFooter>);
    }
  return (
    <Page className={styles.bodyBackground}>
      <h1 className={styles.myTitle}>上海征地房屋补偿</h1>
      <Form className={styles.formWrapStyle}>
        <FormCell className={styles.formInputBorderOne}>
          <CellHeader>
            <Label style={{width:"auto"}}><span className={styles.accountIcon}/></Label>
          </CellHeader>
          <CellBody>
            <Icon value="warn" />
            <Input type="tel"  onBlur={(event)=>this.telCheck(event)} style={{color:"#fff"}} placeholder="手机号"/>
          </CellBody>
        </FormCell>
        <FormCell className={styles.formInputBorderTwo}>
          <CellHeader>
            <Label style={{width:"auto"}}><span className={styles.passwordIcon}/></Label>
          </CellHeader>
          <CellBody>
            <Input type="tel" placeholder="验证码"  onBlur={(event)=>this.telYanZhengMa(event)} style={{color:"#fff"}}/>
          </CellBody>
          {button}
        </FormCell>
      </Form>
      <ButtonArea className={styles.buttonWrapStyle}>
        <Button
          className={styles.buttonStyle}
          //button to display toptips
          onClick={ this.registerClick}>
          立即登陆
        </Button>
      </ButtonArea>
      <Footer>
        <FooterText  style={{color:"#fff"}}>
          Copyright © 2017-2018 www.proland.org.cn
        </FooterText>
      </Footer>
      <Toptips type="warn"
               show={this.props.login.showToptips}
      >
        {this.props.login.errormsg}
      </Toptips>
    </Page>
  );
  };
}

IndexPage.propTypes = {
  login: PropTypes.object,
  middleSelect:PropTypes.object,
};
// 指定订阅数据，这里关联了 login
function mapStateToProps({ login, middleSelect }) {
  return {login, middleSelect};
}
export default connect(mapStateToProps)(IndexPage);
